
#ifndef __LCD_H
#define __LCD_H

typedef enum _dspl {ON = 0x3F, OFF = 0x3E} _display;
typedef enum _crstl {First = 1, Second = 2} _crystal;

#define LCD_CMD1	0x68000000
#define LCD_CMD2	0x70000000

#define LCD_DATA1	0x6C000000
#define LCD_DATA2	0x74000000

void __SysTickInit(void);				//   
void Pause8us(void);					//   8 
unsigned char ReadStatus(_crystal);		//    LCD
void PortsForLCD(void);					//   /   
void SystemBusInit(void);				//    
void ResetLCD(void);					//  LCD
void SetStartLine(unsigned int);		//    LCD
void DisplayOnOff(_display);			// / LCD 
void SetPage(unsigned int, _crystal);	//    LCD (  8 )
void SetAddress(unsigned int);			//       ()
unsigned char ReadStatus(_crystal);		//   LCD
void WriteByte(unsigned char, unsigned char);	//      LCD
unsigned char ReadByte(unsigned int, unsigned int);			//      LCD
void ClearLCD(void);					//   LCD
void ClearPage(unsigned char, _crystal);//      LCD
void ClearPageAtTo(unsigned int, unsigned int, unsigned int);	//  LCD      
void LCDInit(void);						//  LCD-
__inline void EnableSysTick(void);		//         
__inline void DisableSysTick(void);		//         
void __SysTickInit(void);				//   
void SysTick_Handler(void);				//    
void Pause8us(void);					//   8 

#endif	//__LCD_H

