
#ifndef __CONFIG_C
#define __CONFIG_C

#include "../inc/OPORA/opora.h"
#include "../inc/CONFIG/config.h"

//--- Clock configuration ---
void CoreClockConfig()
{
	RST_CLK->HS_CONTROL = 0x00000001;			//HSE - On; Osc mode On
	while((RST_CLK->CLOCK_STATUS&RST_CLK_CLOCK_STATUS_HSE_RDY)==0);	//Wait until HSE not ready
	RST_CLK->PER_CLOCK |= 0x08 | 1<<27;		    //EEPROM_CTRL and BKP Clock enable
	EEPROM->CMD=0;
    BKP->REG_0E |= 0x5<<3 | 0x5;                // SelectRI and LOW - clock upto 40 MHz
	RST_CLK->PER_CLOCK&=(~0x08);				//EEPROM_CTRL Clock disable
	RST_CLK->CPU_CLOCK=0x00000002;				//CPU_C1=HSE (8MHz)
	RST_CLK->PLL_CONTROL=RST_CLK_PLL_CONTROL_PLL_CPU_MUL_2|RST_CLK_PLL_CONTROL_PLL_CPU_ON;	//PLL_CPU_MULL=2, PLL_CPU On
	while((RST_CLK->CLOCK_STATUS&RST_CLK_CLOCK_STATUS_PLL_CPU_RDY)==0);	//Wait until CPU PLL not ready
	RST_CLK->CPU_CLOCK=0x106;					//CPU clock=CPUPLL (16MHz)
}

void PortsConfig()
{
	RST_CLK->PER_CLOCK|=(0x1F<<21)|(1<<29);	//Enable clock of PORTA, PORTB, PORTC, PORTD, PORTE, PORTF

	//Config Data Bus
	PORTA->FUNC=0x55555555;			//PORTA - DATA bus
	PORTA->ANALOG=0xFFFF;			//PORTA - digital
	PORTA->PWR=0xAAAAAAAA;			//PORTA - middle speed

	PORTB->FUNC=0x55555555;			//PORTB - DATA bus
	PORTB->ANALOG=0xFFFF;			//PORTB - digital
	PORTB->PWR=0xAAAAAAAA;			//PORTB - middle speed

	//Config ~OE, ~WE, BE3, BE2, BE1, BE0
	PORTC->FUNC=0x02A80005;			//PORTC[12..9] - BE3, BE2, BE1, BE0; PORTC[1..0] - ~RD(~OE), ~WR(~WE)
	PORTC->ANALOG=0x1E03;			//PORTC[12..9], PORTC[1..0] - digital
	PORTC->PWR=0x02A8000A;			//PORTC - middle speed

	//Config Address Bus and CS
	PORTF->FUNC=0xAAAAA800;			//PORTF[15..5] - ADDRESS bus
	PORTF->ANALOG=0xFFE0;			//PORTF[15..5] - digital
	PORTF->PWR=0xAAAAA800;			//PORTF - middle speed

	PORTD->FUNC=0x80000000;			//PORTD_15 - ADDRESS[13]
	PORTD->ANALOG=0x8000;			//PORTD_15 - digital
	PORTD->PWR=0x80000000;			//PORTD - middle speed

	PORTE->FUNC=0x00000AAA;			//PORTE[5..0] - ADDRESS[19..14], PORTE_7 - ADDRESS[21], 
	PORTE->RXTX=0x0040;				//PORTE_6=1 (~CS1=1)
	PORTE->OE=0x00C0;				//PORTE_6 - Output
	PORTE->ANALOG=0x00FF;			//PORTE[7..0] - digital
	PORTE->PWR=0x0000AAAA;			//PORTE - middle speed

	PORTE->CLRTX=0x40;
	PORTE->SETTX=0x80;

	//Config LEDS
	PORTD->RXTX=0;
	PORTD->OE|=0x7F80;
	PORTD->ANALOG|=0x7F80;			//PORTD[14..7] - digital
	PORTD->PWR|=0x3FFFC000;			//PORTD - fast speed
}

void ExternalBusConfig()
{
	RST_CLK->PER_CLOCK|=1<<30;		//Enable clock of External Bus
	EXT_BUS_CNTRL->EXT_BUS_CONTROL=(0x0002)|(2<<12);	//RAM enable
}

#endif	//__CONFIG_C
