
#ifndef	__ROM_FUNCTIONS_C
#define __ROM_FUNCTIONS_C

#include "..\inc\OPORA\opora.h"
#include "..\inc\ROM\RomFunctions.h"

//   32-    address  
// address - ,       
//			value - ,     
// :	0 -  ,   ;
//							1 -   ,  .
uint32_t WriteWordToROM(uint32_t address, uint32_t value)
{
	uint32_t	*ptr;
	uint32_t	tmp;
	
	ptr=(uint32_t*)(START_ADDR+(0x555<<2));
	*ptr=0xAAAAAAAA;

	ptr=(uint32_t*)(START_ADDR+(0x2AA<<2));
	*ptr=0x55555555;

	ptr=(uint32_t*)(START_ADDR+(0x555<<2));
	*ptr=0xA0A0A0A0;

	ptr=(uint32_t*)(START_ADDR+(address<<2));
	*ptr=value;

	tmp=*ptr;

	while(1)
	{
		if((tmp&0x80808080)!=(value&0x80808080))
		{
			if((tmp&0x20202020)==0x20202020)
			{
				tmp=*ptr;
				if((tmp&0x80808080)==(value&0x80808080))	break;
				else	return 1;
			}
		tmp=*ptr;		
		}
		else	break;
	}
	return 0;
}

//      NumSector  
// NumSector -    ( 0  3)
// :	0 -  ,  ;
//							1 -   ,  .
uint32_t EraseSectorToROM(uint32_t NumSector)
{
	uint32_t	*ptr;
	uint32_t	tmp1, tmp2;
// 	
	ptr=(uint32_t*)(START_ADDR+(0x555<<2));
	*ptr=0xAAAAAAAA;
// 
	ptr=(uint32_t*)(START_ADDR+(0x2AA<<2));
	*ptr=0x55555555;
// 
	ptr=(uint32_t*)(START_ADDR+(0x555<<2));
	*ptr=0x80808080;
// 
	ptr=(uint32_t*)(START_ADDR+(0x555<<2));
	*ptr=0xAAAAAAAA;
// 
	ptr=(uint32_t*)(START_ADDR+(0x2AA<<2));
	*ptr=0x55555555;
// 
	ptr=(uint32_t*)(START_ADDR+(NumSector<<18));
	*ptr=0x30303030;

	while(1)
	{	
		tmp1=*ptr;
		tmp2=*ptr;
		if(tmp1!=tmp2)
		{
			if((tmp2&0x20202020)==0x20202020)
			{
				tmp1=*ptr;
				tmp2=*ptr;
				if(tmp1==tmp2) break;
				else	return 1;
			}
		}
		else break;
	}
	return 0;
}

void EraseFullChipToROM(void)
{
	
}
//      
// address - ,       
//			inv -       
// :	0 -      
//							1 -       
uint32_t TestData(uint32_t address, uint32_t inv)
{
	uint32_t *ptr, tmp, data, res;
	
	ptr=(uint32_t*)address;

	PORTE->CLRTX=0x40;
	res=1;
		
	if(!inv)
	{
		for(tmp=0;tmp<0x40000;tmp++)
		{
			data=*ptr++;
			if(data!=tmp)
			{
				res=0;
				break;
			}
		}
	}
	else
	{
		for(tmp=0;tmp<0x40000;tmp++)
		{
			data=*ptr++;
			if(data!=(~tmp))
			{
				res=0;
				break;
			}
		}
	}

	PORTE->SETTX=0x40;
	return res;
}


#endif	//__ROM_FUNCTIONS_C

