
#include "opora.h"

#define REVISION_2

void ClkConfig(void);
void PortConfig(void);
void LED_On(uint32_t);

uint32_t Current_Led=0, i;
int main()
{
	ClkConfig();
	PortConfig();
	while(1)
	{
		LED_On(Current_Led);
		Current_Led++;
		if(Current_Led>7) Current_Led=0;
		for(i=0;i<100000;i++);
	}
}

//--- Clock configuration ---
void ClkConfig()
{
#ifdef REVISION_2
	RST_CLK->HS_CONTROL = 0x00000001;			//HSE - On; Oscillator mode
	while((RST_CLK->CLOCK_STATUS&0x04)!=0x04);	//Wait until HSE not ready
	RST_CLK->CPU_CLOCK = 0x00000002;			//CPU_C1 = HSE (8MHz)
	RST_CLK->PLL_CONTROL=(1<<2)|(2<<8);			//CPU PLL On, PLL_MULL = 2
	while((RST_CLK->CLOCK_STATUS&0x02)!=0x02);	//Wait until PLL not ready
	RST_CLK->PER_CLOCK|=0x08;					//EEPROM_CTRL clock enable
	EEPROM->CMD=0;
	RST_CLK->PER_CLOCK&=(~0x08);				//EEPROM_CTRL clock disable
	RST_CLK->CPU_CLOCK = 0x00000106;			//HCLK = PLL clock (24MHz)
#else
	RST_CLK->HS_CONTROL = 0x00000003;			//HSE - On; Generator mode On
	while((RST_CLK->CLOCK_STATUS&0x04)!=0x04);	//Wait until HSE not ready
	RST_CLK->PER_CLOCK|=0x08;					//EEPROM_CTRL clock enable
	EEPROM->CMD=0;
	RST_CLK->PER_CLOCK&=(~0x08);				//EEPROM_CTRL clock disable
	RST_CLK->CPU_CLOCK = 0x00000102;			//CPU Clock = HSE (25MHz)
#endif	//REVISION_2
	RST_CLK->PER_CLOCK |= (1<</*22*/24); 				//clock of PORTD On
}

//--- Ports configuration ---
void PortConfig()
{
/*
	PORTB->FUNC = 0x00000000;
	PORTB->RXTX = 0x0000;
	PORTB->OE = 0x7F80;
	PORTB->ANALOG = 0x7F80;
	PORTB->PWR = 0x3FFFC000;
*/
	
	PORTD->FUNC = 0x00000000;
	PORTD->RXTX = 0x0000;
	PORTD->OE = 0x7F80;
	PORTD->ANALOG = 0x7F80;
	PORTD->PWR = 0x3FFFC000;
	
}

//--- Function for Switch On one led ---
void LED_On(uint32_t Led)
{
	PORTB->RXTX^=(1<<(Led+7));
}

	
