
#ifndef	__LCDGRAPHIC_C
#define __LCDGRAPHIC_C

#include "LCDGraphic.h"
#include "LCD.h"
/************************************************
***       -12864
***	  
************************************************/

//--------------------------------------------------------------------------------------
//***        
//*** :	X0 -     (0...127)
//***				Y0 -  y   (0...63)
//*** 				X1 -     (0...127)
//***				Y1 -  y   (0...63)
//***   
//--------------------------------------------------------------------------------------
void DrawLine(int x0, int y0, int x1, int y1)
{
	unsigned char Length,Height;
	int Xc,Yc;
	
	if(x1 > x0) 	Length = x1 - x0;
	else			Length = x0 - x1;
	if(Length>128)	Length = 128;

	if(y1 > y0)		Height = y1 - y0;
	else 			Height = y0 - y1;
	if(Height>63)	Height = 64;

	if(Length != 0)				//    0
	{
		if(Height != 0)			//    0
		{
			if(Length>=Height)	//    , 
			{
				if(x0<x1)
				{
					if(y0<y1)			//(x0<x1)&(y0<y1)
					{
						Yc = y0;
						for(Xc=x0;Xc<=x1;)
						{
							PutPixel(Xc,Yc);
							Xc++;
							Yc = y0 + (Xc-x0)*Height/Length;
						}
					}
					else				//(x0<x1)&(y0>y1)
					{
						Yc = y0;
						for(Xc=x0;Xc<=x1;)
						{
							PutPixel(Xc,Yc);
							Xc++;
							Yc = y0 - (Xc-x0)*Height/Length;
						}
					}
					
				}
				else
				{
					if(y0<y1)			//(x0>x1)&(y0<y1)
					{
						Yc = y1;
						for(Xc=x1;Xc<=x0;)
						{
							PutPixel(Xc,Yc);
							Xc++;
							Yc = y0 + (x0-Xc)*Height/Length;
						}
					}
					else				//(x0>x1)&(y0>y1)
					{
						Yc = y1;
						for(Xc=x1;Xc<=x0;)
						{
							PutPixel(Xc,Yc);
							Xc++;
							Yc = y0 - (x0-Xc)*Height/Length;
						}
					}
				}
			}
			else				//    , 
			{
				if(y0<y1)				
				{
					if(x0<x1)			//(y0<y1)&(x0<x1)
					{
						Xc = x0;
						for(Yc=y0;Yc<=y1;)
						{
							PutPixel(Xc,Yc);
							Yc++;
							Xc = x0 + (Yc-y0)*Length/Height;
						}
					}
					else				//(y0<y1)&(x0>x1)
					{
						Xc = x0;
						for(Yc=y0;Yc<=y1;)
						{
							PutPixel(Xc,Yc);
							Yc++;
							Xc = x0 - (Yc-y0)*Length/Height;
						}
					}

				}
				else
				{
					if(x0<x1)			//(y0>y1)&(x0<x1)
					{
						Xc = x1;
						for(Yc=y1;Yc<=y0;)
						{
							PutPixel(Xc,Yc);
							Yc++;
							Xc = x0 + (y0-Yc)*Length/Height;
						}
					}
					else				//(y0>y1)&(x0>x1)
					{
						Xc = x1;
						for(Yc=y1;Yc<=y0;)
						{
							PutPixel(Xc,Yc);
							Yc++;
							Xc = x0 - (y0-Yc)*Length/Height;
						}
					}
				}
			}
		}
		else					//   0 (  )
		{
			DrawHorizontalLine(x0,x1,y0);
		}
	}
	else 						//   0
	{
		if(Height != 0)			//    0,   
		{
			DrawVerticalLine(x0, y0, y1);
		}
		else					//   0,  
		{
			PutPixel(x0,y0);
		}
	}

}
//--------------------------------------------------------------------------------------
//***        
//*** :	X0 -    	(0...127)
//***				Y0 -  y  	(0...63)
//***   
//--------------------------------------------------------------------------------------
void PutPixel(uint8_t X0,uint8_t Y0)
{
	uint8_t Page,i;
	Page = GetPage(Y0);
	i = ReadByte(Page,X0);
	Y0 = BitSet(Y0);	// Y0  ,     ,     0.
	i |= Y0;
	WriteByte(i,X0);	//   LCD
}
//--------------------------------------------------------------------------------------
//***     
//*** :	X0 -  x   (0...127)
//***				Y0 -     y (0...63)
//***				Y1 -     y (0...63)
//***   
//--------------------------------------------------------------------------------------
void DrawVerticalLine(uint8_t X0, uint8_t Y0, uint8_t Y1)
{
	uint8_t Temp;
	if(Y0>Y1)
	{
		Temp = Y1;
		Y1 = Y0;
		Y0 = Temp;
	}
	for(;Y0<=Y1;Y0++)
	{
		PutPixel(X0,Y0);
	}
}
//--------------------------------------------------------------------------------------
//***     
//*** :	X0 -   x   (0...127)
//***				X1 -      (0...127)
//***				Y0 -  y   (0...63)
//***   
//--------------------------------------------------------------------------------------
void DrawHorizontalLine(uint8_t X0, uint8_t X1, uint8_t Y0)
{
	uint8_t Temp;
	if(X0>X1)
	{
		Temp = X1;
		X1 = X0;
		X0 = Temp;
	}
	for(;X0<=X1;X0++)
	{
		PutPixel(X0,Y0);
	}
}

//--------------------------------------------------------------------------------------
//***     ()
//*** :	X0 -  x     (0...127)
//***				Y0 -       (0...63)
//***				X1 -  x     (0...127)
//***				Y1 -       (0...63)
//***   
//--------------------------------------------------------------------------------------
void DrawRect(uint8_t X0, uint8_t Y0, uint8_t X1, uint8_t Y1)
{
	if(X0-X1==0)
	{
		DrawVerticalLine(X1, Y0, Y1);
		return;
	}
	if(Y0-Y1==0)
	{
		DrawHorizontalLine(X0, X1, Y0);
		return;
	}
	DrawHorizontalLine(X0, X1, Y0);
	DrawVerticalLine(X1, Y0+1, Y1);
	DrawHorizontalLine(X0, X1-1, Y1);
	DrawVerticalLine(X0, Y0+1, Y1-1);
}

//--------------------------------------------------------------------------------------
//***     ()
//*** :	X0 -  x    (0...127)
//***				Y0 -      (0...63)
//***				X1 -  x    (0...127)
//***				Y1 -      (0...63)
//***				X2 -  x    (0...127)
//***				Y2 -      (0...63)
//***   
//--------------------------------------------------------------------------------------
void DrawTriangle(uint8_t X0, uint8_t Y0, uint8_t X1, uint8_t Y1, uint8_t X2, uint8_t Y2)
{
	DrawLine(X0,Y0,X1,Y1);
	DrawLine(X1,Y1,X2,Y2);
	DrawLine(X0,Y0,X2,Y2);	
}

//--------------------------------------------------------------------------------------
//***      ,    
//***       (    ,  
//***     )
//--------------------------------------------------------------------------------------
uint8_t BitSet(uint8_t Val)
{
	return (1<<(Val%8));
}
//--------------------------------------------------------------------------------------


//--------------------------------------------------------------------------------------
//***    ,    ,   . 
//--------------------------------------------------------------------------------------
uint8_t GetPage(uint8_t Val)	//    ( 0  7)     Val ( 0  63)
{
	if(Val > 63) return 0;
	return (uint8_t)(Val/8);
}

#endif	//__LCDGRAPHIC_C
