
#include "opora.h"
#include "config.h"

uint32_t temp;
uint32_t ReceiveWord,LastTrueCmd,TempCmd,refresh;

void MIL_STD_1553B1_Handler(void);

int main()
{
	ClkConfig();
	PortConfig();
	MilStd1553Init();
	MilStd1553DataInit();
	NVIC_EnableIRQ(MIL_STD_1553B1_IRQn);
	LastTrueCmd=0;
	while(1);
}

void MIL_STD_1553B1_Handler()
{
	uint16_t Status;
	uint32_t i,j;

	Status = MIL_STD_15531->STATUS;

	if((Status&0x08)==0x08)		//Error
	{
		MIL_STD_15531->CONTROL&=0xFFFBFFFF;	//      IDLE
		MIL_STD_15531->StatusWord1=(MYADDR<<11)|0x400;
		if(refresh==1)
		{
			LastTrueCmd=TempCmd;
			refresh=0;
		}
	}
	else
	{
		if ((Status&0x02)==0x02)	//True word
		{
			ReceiveWord=MIL_STD_15531->CommandWord1;
			if(((ReceiveWord&(0x1F<<5))==(0x1F<<5))||((ReceiveWord&(0x1F<<5))==0))	//   
			{
				if(((ReceiveWord&(1<<10)==(1<<10))&&((ReceiveWord&0x1F)>0x08)&&((ReceiveWord&0x1F)<0x10))||((ReceiveWord&0x1F)>0x15))	//          
				{
					if((ReceiveWord&(0x1F<<11))==(0x1F<<11))	MIL_STD_15531->StatusWord1=(MYADDR<<11)|(1<<10)|(1<<4);	//  ,   ,   
					else										MIL_STD_15531->StatusWord1=(MYADDR<<11)|(1<<10);			//  ,   
					LastTrueCmd=MIL_STD_15531->CommandWord1;
					MIL_STD_15531->CONTROL|=0x00040000;
					return;
				}
			}
			if((MIL_STD_15531->MSG==0x2420)&&((MIL_STD_15531->CommandWord1&0x1F)==0x12))	//      (   )
			{
				MIL_STD_15531->StatusWord1=MYADDR<<11;
				MIL_STD_15531->ModeData=LastTrueCmd;	
			}
			else
			{
				refresh=1;
				TempCmd=LastTrueCmd;
				if((MIL_STD_15531->MSG==0x1008)||(MIL_STD_15531->MSG==0x0200))	//   -    
					LastTrueCmd=MIL_STD_15531->CommandWord2;
				else
					LastTrueCmd=MIL_STD_15531->CommandWord1;
			}
			if(!(((MIL_STD_15531->MSG==0x0410)&&((MIL_STD_15531->CommandWord1&0x1F)==0x02))||((MIL_STD_15531->MSG==0x2420)&&((MIL_STD_15531->CommandWord1&0x1F)==0x12))) )
			//      " "   "  "
			{
				switch(MIL_STD_15531->MSG)
				{
					case 0x0080:
					case 0x0100:
					case 0x0200:
					case 0x0400:
					case 0x0800:	MIL_STD_15531->StatusWord1=(MYADDR<<11)|(1<<4);	break;	//       
					default:		MIL_STD_15531->StatusWord1=MYADDR<<11; break;			//  
				}
			}
			if((MIL_STD_15531->MSG==0x0410)||(MIL_STD_15531->MSG==0x0400))	//         
			{
				if((MIL_STD_15531->CommandWord1&0x1F)==0x04)	//    	
				{
					if((Status&0x30)==0x10) MIL_STD_15531->CONTROL&=0xFFFFFFDF;
					else if((Status&0x30)==0x20) MIL_STD_15531->CONTROL&=0xFFFFFFEF;
				}
				else if((MIL_STD_15531->CommandWord1&0x1F)==0x05)	//    
				{
					if((Status&0x30)==0x10)	MIL_STD_15531->CONTROL|=0x20;	
					else if((Status&0x30)==0x20)	MIL_STD_15531->CONTROL|=0x10;
				}
			}
			if((MIL_STD_15531->MSG==0x0040)||(MIL_STD_15531->MSG==0x0800))
			//        
			{
				if((MIL_STD_15531->CommandWord1&0x1F)==0x14)	//  " i- "
				{
					if((Status&0x30)==0x10)	MIL_STD_15531->CONTROL&=0xFFFFFFDF;
					else if((Status&0x30)==0x20)	MIL_STD_15531->CONTROL&=0xFFFFFFEF;
				}
				else if((MIL_STD_15531->CommandWord1&0x1F)==0x15)	//  " i- "
				{
					if((Status&0x30)==0x10)	MIL_STD_15531->CONTROL|=0x20;
					else if((Status&0x30)==0x20)	MIL_STD_15531->CONTROL|=0x10;
				}
			}
		}
		if((Status&0x04)==0x04)	//     
		{
			if(((MIL_STD_15531->MSG==0x0040)||(MIL_STD_15531->MSG==0x0800))&&((MIL_STD_15531->CommandWord1&0x1F)==0x11))	//        " ( )"
			{
				ReceiveWord=(MIL_STD_15531->CONTROL&0xFFFFF83F)|((MIL_STD_15531->ModeData&0x1F)<<6);	//     
				MIL_STD_15531->CONTROL=ReceiveWord;
			} 
			refresh=0;
			if(((MIL_STD_15531->CommandWord1|0xFBFF)==0xFBFF)&&((MIL_STD_15531->CommandWord1&0x3E0)!=0x3E0)&&((MIL_STD_15531->CommandWord1|0xFC1F)!=0xFC1F))	//         
			{
				if((MIL_STD_15531->CommandWord1&0x20)==0x20)
				{
					for(j=0;j<=0x80;j=j+4)
					{
						i=*((volatile uint32_t *)(MIL_STD_15531_BASE+0x80+j));
						*((volatile uint32_t *)(MIL_STD_15531_BASE+0x80+j))=i;
					}
				}
			}		
		}
	}
	MIL_STD_15531->CONTROL|=0x00040000;	//18    1 (      MR)

}

