
#ifndef __CONFIG_C
#define __CONFIG_C

#include "opora.h"

void ClockCfg()
{
	unsigned int temp;
	RST_CLK->HS_CONTROL=1;					//oscillator mode
	while((RST_CLK->CLOCK_STATUS&0x04)==0);	//wait, until frequency unstable
	RST_CLK->PER_CLOCK|=0x08;						//EEPROM Clock enable
	EEPROM->CMD=0;							//Delay = 0
	RST_CLK->CPU_CLOCK=0x00000002;			//CPU_C1 frequency 8MHz
	
	RST_CLK->PLL_CONTROL=0x0104;			//CPU_PLL On, USB_MUL_MULL=1
	while((RST_CLK->CLOCK_STATUS&0x02)==0);	//wait, until PLL frequency unstable

	RST_CLK->CPU_CLOCK=0x00000106;			//CPU frequency 16MHz
	
	temp=RST_CLK->PER_CLOCK;
	temp|=0x01004008;
	RST_CLK->PER_CLOCK=temp;				//PORTD clock enable, Timer1 clock enable, EEPROM clock enable

	RST_CLK->TIM_CLOCK=0x01000001;			//Timer_1 clock enable Timer_1_Clock=HCLK/2
}

void PortCfg()
{
//------- PortD for LEDS -------
	PORTD->FUNC=0;							//Port_D - ports
	PORTD->ANALOG=0xFFFF;					//Port_D - digital
	PORTD->RXTX=0;							
	PORTD->OE=0x7F80;						//Port_D[14..7] - outputs
	PORTD->PWR=0x3FFFC000;					//Port_D[14..7] - fast edge
}

void Timer1Cfg()
{
	TIMER1->CNT=0;
	TIMER1->CNTRL=0x0100;
}

#endif	//__CONFIG_C

