
#ifndef __LCDB_C
#define __LCDB_C

/************************************************
***       -12864
***	  
************************************************/

#include "font.h"
#include "LCD.h"
#include "LCD_b.h"

//--------------------------------------------------------------------------------------
//***         68  (6 - , 8 - )
//*** :	Symbol - ,   
//***				Crystal -  LCD,     
//***   
//--------------------------------------------------------------------------------------
void PrintSymbol(uint8_t Symbol, uint8_t Address, uint8_t Method)
{
	uint32_t Offset= Symbol*6;
	if(Method==0)
	{
		WriteByte(Font_6x8_Data[Offset],Address);
		Address++;
		WriteByte(Font_6x8_Data[Offset+1],Address);
		Address++;	 
		WriteByte(Font_6x8_Data[Offset+2],Address);
		Address++;
		WriteByte(Font_6x8_Data[Offset+3],Address);
		Address++;
		WriteByte(Font_6x8_Data[Offset+4],Address);
		Address++;
		WriteByte(Font_6x8_Data[Offset+5],Address);
	}
	else
	{
		WriteByte(~Font_6x8_Data[Offset],Address);
		Address++;
		WriteByte(~Font_6x8_Data[Offset+1],Address);
		Address++;	 
		WriteByte(~Font_6x8_Data[Offset+2],Address);
		Address++;
		WriteByte(~Font_6x8_Data[Offset+3],Address);
		Address++;
		WriteByte(~Font_6x8_Data[Offset+4],Address);
		Address++;
		WriteByte(~Font_6x8_Data[Offset+5],Address);
	}
}
//--------------------------------------------------------------------------------------
//***       
//*** :	Text -    ,   
//***				Page -   LCD,     
//***				Address - ,       LCD 
//***   
//***       000!
//--------------------------------------------------------------------------------------

void PrintConstText(uint8_t* String, uint8_t Page, uint8_t Address, uint8_t Method)
{
//   !
	int LenWord, Length=0;
	uint8_t* ms;

	ClearPage(Page,First);
	ClearPage(Page,Second);
/*
	if(Address<64)
	{
		SetAddress(Address);
		SetAddress(64);
	}
	else
	{
		SetAddress(0);
		SetAddress(Address);
	}
*/	
	SetPage(Page,First);
	SetPage(Page,Second);

	ms = String;
	while(*(ms++)!=0) Length++;

	for(LenWord=0;LenWord<Length;LenWord++,Address+=6)	PrintSymbol(String[LenWord],Address,Method);

}

//--------------------------------------------------------------------------------------
//***          (   )
//*** :	Text -   ,   
//***				Value - ,     
//***				Page -   LCD,     
//***				Address - ,       LCD 
//***				Method -      (      )
//***				ntn -  ,     
//***   
//***       000!
//--------------------------------------------------------------------------------------
void PrintText(uint8_t* String, uint32_t Value,uint8_t Page, uint8_t Address, uint8_t Method, notation ntn)
{
//   !
	uint32_t LenWord=0, Length=0, PositionForInsert=0, Temp, ValNumOfChar, ptr;
	uint8_t NewStr[21], CharVal[33];
	uint8_t* ms;

//  
	ms = String;
	while(*(ms++)!=0) Length++;
	if(Length>21) Length = 21;

//    Value
	ms = String;
	while(LenWord++ < Length)
	{
		if(ms[LenWord]=='%')
		{
			PositionForInsert = LenWord;
			break;
		}
	}

//  Value   
	DigitalToChar(&CharVal[0],Value,&ValNumOfChar,ntn);
	
//    
	for(Temp=0;Temp<PositionForInsert;Temp++)	NewStr[Temp] = ms[Temp];
	
//        Value
	if((ValNumOfChar+Temp)>21)
	{
		ptr=ValNumOfChar+Temp-21;	//   ,       
		//    Value   
  		for(LenWord=0;Temp<21;Temp++)	NewStr[Temp] = CharVal[ptr+LenWord++];
	}
	else
	{
		ValNumOfChar+=Temp;
		//    Value   
		for(LenWord=0;Temp<ValNumOfChar;Temp++)	NewStr[Temp] = CharVal[LenWord++];
	}

// ,    
	LenWord = Length - (PositionForInsert + 1);
	PositionForInsert++;
	if((Temp < 21)&&(LenWord!=0))
		for(;(Temp < 21)&&(LenWord!=0);Temp++,LenWord--)	NewStr[Temp] = ms[PositionForInsert++];
	
	SetPage(Page,First);
	SetPage(Page,Second);

	for(LenWord=0;LenWord<Temp;LenWord++)
	{
		PrintSymbol(NewStr[LenWord],Address,Method);
		Address += 6;
	}
}

//--------------------------------------------------------------------------------------
//***     Val   ,    MyStr
//*** :	MyStr -   ,     
//***				(   32 )
//***				Value - ,     
//***				Len - ,     -  
//***				 (   0)
//***				ntn - ,       
//***   
//--------------------------------------------------------------------------------------
void DigitalToChar(uint8_t* MyStr, uint32_t Val, uint32_t* Len, notation ntn)
{
	uint32_t i,f,Temp,j,non=0,div,num;
	uint8_t Arr[33];

//  Val    (    , Arr[0] - , Arr[1] - ,  ..)
	if(ntn==dec)
	{
		div=10;
		num=10;
	}
	else if(ntn==oct)
	{
		div=8;
		num=11;
	}
	else if(ntn==bin)
	{
		div=2;
		num=32;
	}
	else
	{
		div=16;
		num=8;
	}

	for(Temp=0;Temp<num;Temp++)
	{
		i=Val/div;
		f=Val%div;
		if(f<10)	Arr[Temp]=0x30+f;
		else		Arr[Temp]=0x41+(f-10);
		Val=i;
		if(i==0)	//  
		{
			non=Temp;
			break;
		}
	}

//    
	if(ntn==dec)
	{
		if(non==0)
		{
			MyStr[0] = Arr[0];
			MyStr[1] = 0;
			*Len = 1;
			return;
		}
		else
		{
			*Len = 0;
			j = non;
			for(Temp=0;Temp<=j;Temp++)
			{
				MyStr[Temp] = Arr[non--];
				(*Len)++;
			}
			MyStr[Temp] = 0;
			return;
		}
	}
	else if(ntn==oct)
	{
		if(non==0)
		{
			MyStr[0]=Arr[0];
			MyStr[1]=0;
			*Len=1;
			return;
		}
		else
		{
			*Len=0;
			j=non;
			for(Temp=0;Temp<=j;Temp++)
			{
				MyStr[Temp]=Arr[non--];
				(*Len)++;
			}
			MyStr[Temp]=0;
			return;
		}
	}
	else if(ntn==bin)
	{
		if(non==0)
		{
			MyStr[0]=Arr[0];
			MyStr[1]=0;
			*Len=1;
			return;
		}
		else
		{
			*Len=0;
			j=non;
			for(Temp=0;Temp<=j;Temp++)
			{
				MyStr[Temp]=Arr[non--];
				(*Len)++;
			}
			MyStr[Temp]=0;
			return;
		}
	}
	else
	{
		MyStr[0] = '0';
		MyStr[1] = 'x';
		
		if(non == 0)
		{	
			MyStr[2] = Arr[0];
			MyStr[3] = 0;
			*Len = 3;
			return;
		}

		*Len = 2;
		j = non;
		for(Temp=0;Temp<=j;Temp++)
		{
			MyStr[Temp+2] = Arr[non--];
			(*Len)++;
		}
		MyStr[Temp+2] = 0;
	}
}

//--------------------------------------------------------------------------------------
//***      
//*** :	Str -   ,    
//***  : - ,  
//--------------------------------------------------------------------------------------
uint32_t StrLen(uint8_t* Str)
{
	uint8_t* ptr;
	uint32_t Len;

	ptr = Str;
	Len = 0;
	while(*(ptr++)!=0x00)	Len++;

	return Len;
}

#endif	//__LCDB_C
