
/*
  Ethernet        .
*/

void EthCfg(void);                                  //   56001
																			  
int Write_Tx_Descriptor(unsigned short,_tx_current_descriptor*); //   
unsigned short Read_Tx_Descriptor(_tx_descriptor*); //   

int Ready_Rx_Descriptor(_rx_descriptor*);           //   
unsigned short Read_Rx_Descriptor(_rx_descriptor*); //   

unsigned short Read_Packet_Start_Address(_rx_descriptor*);     //     
unsigned short Read_Packet_Length(_rx_descriptor*);            //   

//--------------------------------------------------------------------------------------
//   Ethernet- 56001
//:	
//  
//--------------------------------------------------------------------------------------
void EthCfg()
{
	int i;

		Ethernet->GCTRL = 0x8000;	//Reset 5600VG1U        
		for(i=0;i<1000;i++){}		//Little delay
		Ethernet->GCTRL = 0x4382;						   	
		Ethernet->MinFrame = 0x0040;
    	Ethernet->CollConfig = 0;
    	Ethernet->IPGTx = 0x000A;
    	Ethernet->MAC_ADDR_T = 0x1B0A;
    	Ethernet->MAC_ADDR_M = 0x3D2C;
    	Ethernet->MAC_ADDR_H = 0x5F4E;
        Ethernet->PHY_CTRL = 0x31D0;
		Ethernet->MAC_CTRL = 0x0200;  //Receive broadcast packet and packet with my MAC-address, littel endian ON
}

//--------------------------------------------------------------------------------------
//       
//:	PacketLen -    ,
//			TxCurrentDesc -      
//  
//--------------------------------------------------------------------------------------
int Write_Tx_Descriptor(unsigned short PacketLen, _tx_current_descriptor* TxCurrentDesc)
{
	unsigned int* MyDesc;
	MyDesc = (unsigned int*)(TxCurrentDesc->TxCurrentDescriptor->StartAddress);

	*(MyDesc+1) = PacketLen;
	*(MyDesc+3) = (TxCurrentDesc->FirstEmptyWord>>2)&0x0000FFFF;

	if(TxCurrentDesc->TxCurrentDescriptor->LastDesc == 1) *MyDesc = 0xC000;
	else *MyDesc = 0x8000;

	TxCurrentDesc->FirstEmptyWord += (PacketLen/2)<<2;	//   16-   
												// PacketLen  1 ,     
												//    ,    - 16- !
	if(TxCurrentDesc->FirstEmptyWord > 0x60005FFC)
	{
		TxCurrentDesc->FirstEmptyWord -= 0x00006000;
		TxCurrentDesc->FirstEmptyWord |= 0x60004000;
	}
    return 0;
}

//--------------------------------------------------------------------------------------
//     
//:	TxDesc -     
//:	1 -   
//				0 -   
//--------------------------------------------------------------------------------------
unsigned short Read_Tx_Descriptor(_tx_descriptor* TxDesc)
{
		unsigned int* MyDesc;
		MyDesc = (unsigned int*)(TxDesc->StartAddress);
        if((*MyDesc & 0x8000) == 0x8000) return 1;            //  
        else return 0;                                              // 
}

//--------------------------------------------------------------------------------------
//          
//:	RxDesc -     
//:	0
//--------------------------------------------------------------------------------------
int Ready_Rx_Descriptor(_rx_descriptor* RxDesc)
{
		unsigned int* MyDesc;
		MyDesc = (unsigned int*)(RxDesc->StartAddress);
		if(RxDesc->LastDesc == 1) *MyDesc = 0xC000;	//     
		else *MyDesc = 0x8000;						//     
        return 0;
}

//--------------------------------------------------------------------------------------
//     
//:	RxDesc -     
//:	1 -   
//				0 -  
//--------------------------------------------------------------------------------------
unsigned short Read_Rx_Descriptor(_rx_descriptor* RxDesc)
{
		unsigned int* RDescPointer;
		RDescPointer = (unsigned int*)RxDesc->StartAddress;
        if( (*RDescPointer & 0x8000) == 0x8000) return 1;	
        else return 0;                                      
}

//--------------------------------------------------------------------------------------
//     
//:	RxDesc -     
//:	   
//--------------------------------------------------------------------------------------
unsigned short Read_Packet_Length(_rx_descriptor* RxDesc)
{
		unsigned int* RDescPointer;
		RDescPointer = (unsigned int*)(RxDesc->StartAddress + 4);		//   
        return (unsigned short)(*RDescPointer);       //Temp;
}

//--------------------------------------------------------------------------------------
//   ,       
//:	RxDesc -     
//:	   
//--------------------------------------------------------------------------------------
unsigned short Read_Packet_Start_Address(_rx_descriptor* RxDesc)
{
        unsigned int* RDescPointer;
		RDescPointer = (unsigned int*)(RxDesc->StartAddress + 12);	//    
        return (unsigned short)(*RDescPointer);
}

