/**
  ******************************************************************************
  * @file    1901BC1F_dsp_irq_defs.h
  * @author  Phyton Application Team
  * @version V1.0.0
  * @date    14/01/2011
  * @brief   This file contains all the Special Function Registers definitions
  *          for the DSP_IRQ peripheral unit used in the Milandr 1901BC1F
  *          microcontrollers.
  ******************************************************************************
  * @copy
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, PHYTON SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
  * OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2010 Phyton</center></h2>
  ******************************************************************************
  * FILE 1901BC1F_dsp_irq_defs.h
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __1901BC1F_DSP_IRQ_DEFS_H
#define __1901BC1F_DSP_IRQ_DEFS_H

/** @addtogroup __CMSIS CMSIS
  * @{
  */

/** @addtogroup __1901BC1F_Peripheral_Units 1901BC1F Peripheral Units
  * @{
  */

/** @defgroup Periph_DSP_IRQ DSP_IRQ
  * @{
  */

/** @defgroup Periph_DSP_IRQ_Data_Structures Data Structures
  * @{
  */

/** @defgroup Periph_DSP_IRQ_TypeDef DSP_IRQ_TypeDef
  * @{
  */

typedef struct
{
  __IO uint32_t IRQ;
}DSP_IRQ_TypeDef;

/** @} */ /* End of group Periph_DSP_IRQ_TypeDef */

/** @} */ /* End of group Periph_DSP_IRQ_Data_Structures */

/** @defgroup Periph_DSP_IRQ_Defines Defines
  * @{
  */

/** @defgroup Periph_DSP_IRQ_DSP_IRQ_Bits DSP_IRQ
  * @{
  */

#define DSP_IRQ_DIRQ0_Pos                       0
#define DSP_IRQ_DIRQ0                           ((uint32_t)0x00000001)

#define DSP_IRQ_DIRQ1_Pos                       1
#define DSP_IRQ_DIRQ1                           ((uint32_t)0x00000002)

#define DSP_IRQ_DIRQ2_Pos                       2
#define DSP_IRQ_DIRQ2                           ((uint32_t)0x00000004)

#define DSP_IRQ_DIRQ3_Pos                       3
#define DSP_IRQ_DIRQ3                           ((uint32_t)0x00000008)

#define DSP_IRQ_TIRQ_Pos                        4
#define DSP_IRQ_TIRQ                            ((uint32_t)0x00000010)

#define DSP_IRQ_RIRQ1_Pos                       5
#define DSP_IRQ_RIRQ1                           ((uint32_t)0x00000020)

#define DSP_IRQ_XIRQ1_Pos                       6
#define DSP_IRQ_XIRQ1                           ((uint32_t)0x00000040)

#define DSP_IRQ_RIRQ2_Pos                       7
#define DSP_IRQ_RIRQ2                           ((uint32_t)0x00000080)

#define DSP_IRQ_XIRQ2_Pos                       8
#define DSP_IRQ_XIRQ2                           ((uint32_t)0x00000100)

#define DSP_IRQ_RIRQ3_Pos                       9
#define DSP_IRQ_RIRQ3                           ((uint32_t)0x00000200)

#define DSP_IRQ_XIRQ3_Pos                       10
#define DSP_IRQ_XIRQ3                           ((uint32_t)0x00000400)

#define DSP_IRQ_CDIRQ_Pos                       11
#define DSP_IRQ_CDIRQ                           ((uint32_t)0x00000800)

#define DSP_IRQ_CRIRQ_Pos                       12
#define DSP_IRQ_CRIRQ                           ((uint32_t)0x00001000)

#define DSP_IRQ_DSNR_Pos                        15
#define DSP_IRQ_DSNR                            ((uint32_t)0x00008000)

#define DSP_IRQ_AIRQ0_Pos                       16
#define DSP_IRQ_AIRQ0                           ((uint32_t)0x00010000)

#define DSP_IRQ_AIRQ1_Pos                       17
#define DSP_IRQ_AIRQ1                           ((uint32_t)0x00020000)

#define DSP_IRQ_AIRQ2_Pos                       18
#define DSP_IRQ_AIRQ2                           ((uint32_t)0x00040000)

#define DSP_IRQ_AIRQ3_Pos                       19
#define DSP_IRQ_AIRQ3                           ((uint32_t)0x00080000)

#define DSP_IRQ_ANMI_Pos                        20
#define DSP_IRQ_ANMI                            ((uint32_t)0x00100000)

#define DSP_IRQ_ASNR_Pos                        31
#define DSP_IRQ_ASNR                            ((uint32_t)0x80000000)


/** @} */ /* End of group Periph_DSP_IRQ_DSP_IRQ_Bits */

/** @} */ /* End of group Periph_DSP_IRQ_Defines */

/** @} */ /* End of group Periph_DSP_IRQ */

/** @} */ /* End of group __1901BC1F_Peripheral_Units */

/** @} */ /* End of group __CMSIS */

#endif /* __1901BC1F_DSP_IRQ_DEFS_H */

/******************* (C) COPYRIGHT 2010 Phyton *********************************
*
* END OF FILE 1901BC1F_dsp_irq_defs.h */
