//--------------------------------------------------------------------------------
// Project:	Ethernet MAC
// Author:	Stanislav V. Afanas'ev
// Company:	Milandr
// File:	MAC_types.h
// Version:	1.2
// Date:	22.11.07
//--------------------------------------------------------------------------------
// Description:
//
//--------------------------------------------------------------------------------
#ifndef		__MAC_TYPES__
#define		__MAC_TYPES__

#ifdef		__TMS320C50__
#define		__BIT_ORDER_REVERSE__
#endif		//__TMS320C50__

typedef struct	PACK_state
{
			unsigned int	num;			//  
			unsigned int	stat;			// ﭨ ਯ
} t_PACK_state;


typedef	struct	TX_BD_ctrl
{
#ifdef	__BIT_ORDER_REVERSE__
	volatile unsigned	CS			: 1;	//   饩  ६ । 
	volatile unsigned	UR			: 1;	//   Late Collision
	volatile unsigned	LC			: 1;	// Underrun
	volatile unsigned	RL			: 1;	//  ௠ ࠧ襭 - ७  砥 ᯥ譮 ࠢ 室饣 
	volatile unsigned	RTRY		: 4;	// 稪 - ⮪ । 室饣 
			 unsigned	CRC_DIS		: 1;	// ⪫祭  ⮢  CRC32
			 unsigned	PAD_DIS		: 1;	// ⪫祭  ⮢   MinFrame  쭮  PAD- (1-  ந,  ந)
			 unsigned	PRE_DIS		: 1;	// ⪫祭 । ॠ (1-। ॠ ⪫祭, 0-⠭ )
			 unsigned	reserved	: 2;	// (१ࢨ஢)
			 unsigned	IRQ_EN		: 1;	// 襭 ନ஢ 뢠  । (1-., 0-몫.)
			 unsigned	WRAP		: 1;	//  ᫥ ਯ  ⠡ (1-室  ਯ #0)
	volatile unsigned	RDY			: 1;	//  ﭨ 室饣  (1-⮢, 0-ࠢ/ )
#else	//__BIT_ORDER_REVERSE__
	volatile unsigned	RDY			: 1;	//  ﭨ 室饣  (1-⮢, 0-ࠢ/ )
			 unsigned	WRAP		: 1;	//  ᫥ ਯ  ⠡ (1-室  ਯ #0)
			 unsigned	IRQ_EN		: 1;	// 襭 ନ஢ 뢠  । (1-., 0-몫.)
			 unsigned	reserved	: 2;	// (१ࢨ஢)
			 unsigned	PRE_DIS		: 1;	// ⪫祭 । ॠ (1-। ॠ ⪫祭, 0-⠭ )
			 unsigned	PAD_DIS		: 1;	// ⪫祭  ⮢   MinFrame  쭮  PAD- (1-  ந,  ந)
			 unsigned	CRC_DIS		: 1;	// ⪫祭  ⮢  CRC32
	volatile unsigned	RTRY		: 4;	// 稪 - ⮪ । 室饣 
	volatile unsigned	RL			: 1;	//  ௠ ࠧ襭 - ७  砥 ᯥ譮 ࠢ 室饣 
	volatile unsigned	LC			: 1;	// (१ࢨ஢)
	volatile unsigned	UR			: 1;	//   Late Collision
	volatile unsigned	CS			: 1;	//   饩  ६ । 
#endif	//__BIT_ORDER_REVERSE__
} t_TX_BD_ctrl;


typedef	struct	RX_BD_ctrl
{
#ifdef	__BIT_ORDER_REVERSE__
	volatile unsigned	OR			: 1;	//  ९    ਥ 
	volatile unsigned	LC			: 1;	//   Late Collision
	volatile unsigned	SMB_ERR		: 1;	//   訡    ਥ 
	volatile unsigned	CRC_ERR		: 1;	//   訡 CRC  ਥ 
	volatile unsigned	EF			: 1;	//   訡  ਥ  (᢮   訡 . )
	volatile unsigned	SF			: 1;	//  ਥ    MinFrame
	volatile unsigned	LF			: 1;	//  ਥ    MaxFrame
	volatile unsigned	CF			: 1;	//  ਥ  ࠢ
	volatile unsigned	UCA			: 1;	//  ਥ 㠫쭮    ᮢ MAC-
	volatile unsigned	MCA			: 1;	//  ਥ ப⥫쭮  
	volatile unsigned	BCA			: 1;	//  ਥ 㯯   MAC-ᮬ ᮮ⢥饣 HASH-⠡
			 unsigned	reserved	: 2;	// (१ࢨ஢)
			 unsigned	IRQ			: 1;	// 襭 ନ஢ 뢠  । (1-., 0-몫.)
			 unsigned	WRAP		: 1;	//  ᫥ ਯ  ⠡ (1-室  ਯ #0)
 	volatile unsigned	EMPTY		: 1;	//  ﭨ 室饣  (1-⮢  ਥ , 0- ਭ/ ⮢)
#else	//__BIT_ORDER_REVERSE__
 	volatile unsigned	EMPTY		: 1;	//  ﭨ 室饣  (1-⮢  ਥ , 0- ਭ/ ⮢)
			 unsigned	WRAP		: 1;	//  ᫥ ਯ  ⠡ (1-室  ਯ #0)
			 unsigned	IRQ			: 1;	// 襭 ନ஢ 뢠  । (1-., 0-몫.)
			 unsigned	reserved	: 2;	// (१ࢨ஢)
	volatile unsigned	BCA			: 1;	//  ਥ 㯯   MAC-ᮬ ᮮ⢥饣 HASH-⠡
	volatile unsigned	MCA			: 1;	//  ਥ ப⥫쭮  
	volatile unsigned	UCA			: 1;	//  ਥ 㠫쭮    ᮢ MAC-
	volatile unsigned	CF			: 1;	//  ਥ  ࠢ
	volatile unsigned	LF			: 1;	//  ਥ    MaxFrame
	volatile unsigned	SF			: 1;	//  ਥ    MinFrame
	volatile unsigned	EF			: 1;	//   訡  ਥ  (᢮   訡 . )
	volatile unsigned	CRC_ERR		: 1;	//   訡 CRC  ਥ 
	volatile unsigned	SMB_ERR		: 1;	//   訡    ਥ 
	volatile unsigned	LC			: 1;	//   Late Collision
	volatile unsigned	OR			: 1;	//  ९    ਥ 
#endif	//__BIT_ORDER_REVERSE__
} t_RX_BD_ctrl;

typedef	union	TX_ctrl
{
			unsigned int	all;
			t_TX_BD_ctrl	bit;
} t_TX_ctrl;

typedef	union RX_ctrl
{
			unsigned int	all;
			t_RX_BD_ctrl	bit;
} t_RX_ctrl;

typedef	struct	TX_Buffer_Descriptor
{
			t_TX_ctrl		TX_ctrl;			// ﭨ ࠢ 
			unsigned int	len;				//    (  SA, DA  Length) 			!!!   !!!
			unsigned int	NULL;				//   㪠⥫   (0x0000)
			unsigned int	*data;				// ⥫    (  SA, DA  Length)
} t_TX_Buffer_Descriptor;

typedef	struct	RX_Buffer_Descriptor
{
			t_RX_ctrl		RX_ctrl;			// ﭨ ਥ 
			unsigned int	len;				//    (  SA, DA  Length) 			!!!   !!!
			unsigned int	NULL;				//   㪠⥫   (0x0000)
			unsigned int	*data;				// ⥫    (  SA, DA  Length)
} t_RX_Buffer_Descriptor;


typedef	struct	ETH_Packet
{
			unsigned int	*DA;				// ⥫   ⥫  (DA)
			unsigned int	*SA;				// ⥫   ࠢ⥫  (SA)
			unsigned int	len;				//  
			unsigned int	*data;				// ⥫   
} t_ETH_Pack;

typedef	struct	bits_MAC_CTRL
{
#ifdef	__BIT_ORDER_REVERSE__
			unsigned	LOOPBACK_EN		: 1;	// 祭 ⮢ 몠    / ஢ﬨ MAC  PHY (⨢ ஢ "1" )
			unsigned	BIG_ENDIAN		: 1;	// ४祭  ० BIG ENDIAN ଠ  (⨢ ஢ "1" )
			unsigned	HALFD_EN		: 1;	// ४祭  ० 㯫 ਥ-। (⨢ ஢ "1" )
			unsigned	BCKOF_DIS		: 1;	// ⪫祭 ࢠ  । ७ ࠢ   砥  (⨢ ஢ "1" )
			unsigned	ERR_FRAME_EN	: 1;	// 襭 ਥ ⮢  訡 (⨢ ஢ "1" )
			unsigned	SHORT_FRAME_EN	: 1;	// 襭 ਥ ⮢   MinFrame (⨢ ஢ "1" )
			unsigned	LONG_FRAME_EN	: 1;	// 襭 ਥ ⮢   MaxFrame (⨢ ஢ "1" )
			unsigned	CTRL_FRAME_EN	: 1;	// 襭 ਥ ࠢ ⮢ (⨢ ஢ "1" )
			unsigned	MCA_EN			: 1;	// 祭 ਥ  ⮢ ᮮ⢥ HASH- (⨢ ஢ "1" )
			unsigned	BCA_EN			: 1;	// 祭 ਥ  ப⥫ ⮢ (⨢ ஢ "1" )
			unsigned	PRO_EN			: 1;	// 祭 ਥ  ⮢ ᨬ   - (⨢ ஢ "1" )
			unsigned	PAUSE_EN		: 1;	// 襭 ࠡ⪨ Pause Frame (⨢ ஢ "1" )
			unsigned	reserved		: 2;	// ४祭   ० ᪠஢ ਯ஢,  室  ᫥饬 ⢫  ᨬ  ⮢ (⨢ ஢ "1" )
			unsigned	RX_RST			: 1;	// ࡮ M -஢ (⨢ ஢ "1" )
			unsigned	TX_RST			: 1;	// ࡮  -஢ (⨢ ஢ "1" )
#else	//__BIT_ORDER_REVERSE__
			unsigned	TX_RST			: 1;	// ࡮  -஢ (⨢ ஢ "1" )
			unsigned	RX_RST			: 1;	// ࡮ M -஢ (⨢ ஢ "1" )
			unsigned	reserved		: 2;	// ४祭   ० ᪠஢ ਯ஢,  室  ᫥饬 ⢫  ᨬ  ⮢ (⨢ ஢ "1" )
			unsigned	PAUSE_EN		: 1;	// 襭 ࠡ⪨ Pause Frame (⨢ ஢ "1" )
			unsigned	PRO_EN			: 1;	// 祭 ਥ  ⮢ ᨬ   - (⨢ ஢ "1" )
			unsigned	BCA_EN			: 1;	// 祭 ਥ  ப⥫ ⮢ (⨢ ஢ "1" )
			unsigned	MCA_EN			: 1;	// 祭 ਥ  ⮢ ᮮ⢥ HASH- (⨢ ஢ "1" )
			unsigned	CTRL_FRAME_EN	: 1;	// 襭 ਥ ࠢ ⮢ (⨢ ஢ "1" )
			unsigned	LONG_FRAME_EN	: 1;	// 襭 ਥ ⮢   MaxFrame (⨢ ஢ "1" )
			unsigned	SHORT_FRAME_EN	: 1;	// 襭 ਥ ⮢   MinFrame (⨢ ஢ "1" )
			unsigned	ERR_FRAME_EN	: 1;	// 襭 ਥ ⮢  訡 (⨢ ஢ "1" )
			unsigned	BCKOF_DIS		: 1;	// ⪫祭 ࢠ  । ७ ࠢ   砥  (⨢ ஢ "1" )
			unsigned	HALFD_EN		: 1;	// ४祭  ० 㯫 ਥ-। (⨢ ஢ "1" )
			unsigned	BIG_ENDIAN		: 1;	// ४祭  ० BIG ENDIAN ଠ  (⨢ ஢ "1" )
			unsigned	LOOPBACK_EN		: 1;	// 祭 ⮢ 몠    / ஢ﬨ MAC  PHY (⨢ ஢ "1" )
#endif	//__BIT_ORDER_REVERSE__
} t_bits_MAC_CTRL;

typedef	struct	bits_MAC_INT
{
#ifdef	__BIT_ORDER_REVERSE__
	volatile unsigned	TX_BUSY			: 1;	//  ਭ  㦨  Pause
	volatile unsigned	reserved		: 4;	// (१ࢨ஢)
	volatile unsigned	TXC				: 1;	//  ।  ࠢ
	volatile unsigned	TXE				: 1;	//   訡  । 
	volatile unsigned	TXF				: 1;	//  ᯥ譮 । 

	volatile unsigned	Missed_PKG		: 1;	// (१ࢨ஢)
	volatile unsigned	RXS				: 1;	//  ਥ    MinFrame
	volatile unsigned	RXL				: 1;	//  ਥ    MaxFrame
	volatile unsigned	RXBD_nREADY		: 1;	// (१ࢨ஢)
	volatile unsigned	RXBF_FULL		: 1;	//  ९    ਥ 
	volatile unsigned	RXC				: 1;	//  ਥ  ࠢ
	volatile unsigned	RXE				: 1;	//   訡  ਥ 
	volatile unsigned	RXF				: 1;	//  ᯥ譮 ਥ  
#else	//__BIT_ORDER_REVERSE__
	volatile unsigned	RXF				: 1;	//  ᯥ譮 ਥ  
	volatile unsigned	RXE				: 1;	//   訡  ਥ 
	volatile unsigned	RXC				: 1;	//  ਥ  ࠢ
	volatile unsigned	RXBF_FULL		: 1;	//  ९    ਥ 
	volatile unsigned	RXBD_nREADY		: 1;	// (१ࢨ஢)
	volatile unsigned	RXL				: 1;	//  ਥ    MaxFrame
	volatile unsigned	RXS				: 1;	//  ਥ    MinFrame
	volatile unsigned	Missed_PKG		: 1;	// (१ࢨ஢)

	volatile unsigned	TXF				: 1;	//  ᯥ譮 । 
	volatile unsigned	TXE				: 1;	//   訡  । 
	volatile unsigned	TXC				: 1;	//  ।  ࠢ
	volatile unsigned	reserved		: 4;	// (१ࢨ஢)
	volatile unsigned	TX_BUSY			: 1;	//  ਭ  㦨  Pause
#endif	//__BIT_ORDER_REVERSE__
} t_bits_MAC_INT;
/*
typedef	struct	bits_MAC_INT_MASK
{
#ifdef	__BIT_ORDER_REVERSE__
	unsigned	TX_BUSY		: 1;	//	Busy  
	unsigned				: 4;	//	reserved
	unsigned	TXC			: 1;	//	Transmit Error 
	unsigned	TXE			: 1;	//	Receive Frame 
	unsigned	TXF			: 1;	//	Receive Error 

	unsigned				: 3;	//	reserved
	unsigned	RXBD_nREADY	: 1;	//	Receive Frame 
	unsigned	RXBF_FULL	: 1;	//	Receive Error 
	unsigned	BXC			: 1;	//	Busy  
	unsigned	RXE			: 1;	//	Transmit Control Frame  
	unsigned	RXF			: 1;	//	Receive Control Frame  
#else	//__BIT_ORDER_REVERSE__
#endif	//__BIT_ORDER_REVERSE__
} t_bits_MAC_INT_MASK;
*/
typedef	struct	MAC_PACKETLEN
{
			unsigned int		MIN_FRAME;		// 쭠 ⨬  
			unsigned int		MAX_FRAME;		// ᨬ쭠 ⨬  
} t_MAC_PACKETLEN;

typedef	struct	bits_MAC_COLLCONF
{
#ifdef	__BIT_ORDER_REVERSE__
			unsigned	COLLVALID		: 8;	// ⨬ ६     ( 4BT = 400)
			unsigned	MAXRET			: 4;	// ᨬ쭮 - ७ ࠢ 
			unsigned	reserved 		: 4;	// (१ࢨ஢) 
#else	//__BIT_ORDER_REVERSE__
			unsigned	reserved 		: 4;	// (१ࢨ஢) 
			unsigned	MAXRET			: 4;	// ᨬ쭮 - ७ ࠢ 
			unsigned	COLLVALID		: 8;	// ⨬ ६     ( 4BT = 400)
#endif	//__BIT_ORDER_REVERSE__
} t_bits_MAC_COLLCONF;


typedef	struct	bits_GCTRL
{
#ifdef	__BIT_ORDER_REVERSE__
			unsigned	GLBL_RST		:1;		// 騩  ᥣ ஫ (⨢ ஢ "1")
			unsigned	READ_CLR_STAT	:1;		// ⪠ ⨪  ⥭ (⨢ ஢ "1")
			unsigned	SPI_RST			:1;		//  ஥ ஫ ᫥⥫쭮  (⨢ ஢ "1")
			unsigned	reserved		:2;		// (१ࢨ஢)
			unsigned	SPI_RX_EDGE		:1;		// ⨢ ஭  ஫ ᫥⥫쭮  (1-⥫,0-⥫)
			unsigned	SPI_TX_EDGE		:1;		// ⨢ ஭  ஫ ᫥⥫쭮  (1-⥫,0-⥫)
			unsigned	SPI_DIR			:1;		// 冷 ।  (1-MSB,0-LSB)
			unsigned	SPI_FRAME_POL	:1;		// ⨢ ஢ ᨣ ஢ ᨭ஭樨 ᫥⥫쭮   (1-⥫,0-⥫)
			unsigned	SPI_CLK_POL		:1;		// ୮ ⠪⮢ ᨣ ᫥⥫쭮   (1-᭠,0-ﬠ)
			unsigned	SPI_CLK_PHASE	:1;		//  ⠪⮢ ᨣ ᫥⥫쭮   (1-᭠,0-ﬠ)
			unsigned	SPI_MASTER		:1;		// (१ࢨ஢) 
			unsigned	SPI_DIV			:4;		// (१ࢨ஢)
#else	//__BIT_ORDER_REVERSE__
			unsigned	SPI_DIV			:4;		// (१ࢨ஢)
			unsigned	SPI_MASTER		:1;		// (१ࢨ஢) 
			unsigned	SPI_CLK_PHASE	:1;		//  ⠪⮢ ᨣ ᫥⥫쭮   (1-᭠,0-ﬠ)
			unsigned	SPI_CLK_POL		:1;		// ୮ ⠪⮢ ᨣ ᫥⥫쭮   (1-᭠,0-ﬠ)
			unsigned	SPI_FRAME_POL	:1;		// ⨢ ஢ ᨣ ஢ ᨭ஭樨 ᫥⥫쭮   (1-⥫,0-⥫)
			unsigned	SPI_DIR			:1;		// 冷 ।  (1-MSB,0-LSB)
			unsigned	SPI_TX_EDGE		:1;		// ⨢ ஭  ஫ ᫥⥫쭮  (1-⥫,0-⥫)
			unsigned	SPI_RX_EDGE		:1;		// ⨢ ஭  ஫ ᫥⥫쭮  (1-⥫,0-⥫)
			unsigned	reserved		:2;		// (१ࢨ஢)
			unsigned	SPI_RST			:1;		//  ஥ ஫ ᫥⥫쭮  (⨢ ஢ "1")
			unsigned	READ_CLR_STAT	:1;		// ⪠ ⨪  ⥭ (⨢ ஢ "1")
			unsigned	GLBL_RST		:1;		// 騩  ᥣ ஫ (⨢ ஢ "1")
#endif	//__BIT_ORDER_REVERSE__
} t_bits_GCTRL;


typedef	struct	bits_PHY_CTRL
{
#ifdef	__BIT_ORDER_REVERSE__
			unsigned	PHY_LB			:1;		// 祭 ⮢ 몠     室 ஫ PHY-஢    / (⨢ ஢ "1" )
			unsigned	PHY_DLB			:1;		// 祭 ⮢ 몠     室 ஫ PHY-஢ (⨢ ஢ "1" )
			unsigned	PHY_HALFD		:1;		// 祭 ० 㯫 ਥ-। (⨢ ஢ "1" )
			unsigned	PHY_EARLY_DV	:1;		// 祭 ନࢠ ᨣ RxDV ६  ᨣ CRS (⨢ ஢ "1" )
			unsigned	PHY_DIR			:1;		// 冷 । ⮢  㡠 (1-אַ,0-)
			unsigned	PHY_BASE_2		:1;		// ४祭  ࠡ  ᨠ   ० 㯫 ਥ-। (1-祭  ᨠ쭮 ,0-祭  ⮩ )
			unsigned	PHY_LINK_PERIOD	:6;		// ਮ ᫥ LINK ᮢ -1 ( 1..64 c)
												// ਮ  LINK ᮢ    ਮ ᫥ LINK ᮢ
			unsigned	PHY_RXEN		:1;		// 襭 ࠡ  ஥ ஫ PHY-஢ (⨢ ஢ "1" )
			unsigned	PHY_TXEN		:1;		// 襭 ࠡ  ஥ ஫ PHY-஢ (⨢ ஢ "1" )
			unsigned	PHY_EXT_EN		:1;		// ४祭  ࠡ  譨 ஫஬ PHY-஢ (⨢ ஢ "1" )
			unsigned	PHY_RST			:1;		//  ஥ ஫ ஫ PHY-஢ (⨢ ஢ "1" )
#else	//__BIT_ORDER_REVERSE__
			unsigned	PHY_RST			:1;		//  ஥ ஫ ஫ PHY-஢ (⨢ ஢ "1" )
			unsigned	PHY_EXT_EN		:1;		// ४祭  ࠡ  譨 ஫஬ PHY-஢ (⨢ ஢ "1" )
			unsigned	PHY_TXEN		:1;		// 襭 ࠡ  ஥ ஫ PHY-஢ (⨢ ஢ "1" )
			unsigned	PHY_RXEN		:1;		// 襭 ࠡ  ஥ ஫ PHY-஢ (⨢ ஢ "1" )
			unsigned	PHY_LINK_PERIOD	:6;		// ਮ ᫥ LINK ᮢ -1 ( 1..64 c)
												// ਮ  LINK ᮢ    ਮ ᫥ LINK ᮢ
			unsigned	PHY_BASE_2		:1;		// ४祭  ࠡ  ᨠ   ० 㯫 ਥ-। (1-祭  ᨠ쭮 ,0-祭  ⮩ )
			unsigned	PHY_DIR			:1;		// 冷 । ⮢  㡠 (1-אַ,0-)
			unsigned	PHY_EARLY_DV	:1;		// 祭 ନࢠ ᨣ RxDV ६  ᨣ CRS (⨢ ஢ "1" )
			unsigned	PHY_HALFD		:1;		// 祭 ० 㯫 ਥ-। (⨢ ஢ "1" )
			unsigned	PHY_DLB			:1;		// 祭 ⮢ 몠     室 ஫ PHY-஢ (⨢ ஢ "1" )
			unsigned	PHY_LB			:1;		// 祭 ⮢ 몠     室 ஫ PHY-஢    / (⨢ ஢ "1" )
#endif	//__BIT_ORDER_REVERSE__
} t_bits_PHY_CTRL;

typedef	struct	bits_PHY_STAT
{
#ifdef	__BIT_ORDER_REVERSE__
	volatile unsigned	PHY_EXT_CRS		:1;		//   譥 ஫ PHY-஢  稨 饩  
	volatile unsigned	PHY_EXT_COL		:1;		//   譥 ஫ PHY-஢  稨   
	volatile unsigned	reserved3		:3;		// (१ࢨ஢)
	volatile unsigned	PHY_EXT_LINK	:1;		//   譥 ஫ PHY-஢  稨 祭  
	volatile unsigned	reserved2		:2;		// (१ࢨ஢)
	volatile unsigned	PHY_INT_CRS		:1;		//  ஥ ஫ PHY-஢  稨 饩  
	volatile unsigned	PHY_INT_COL		:1;		//  ஥ ஫ PHY-஢  稨   
	volatile unsigned	PHY_INT_LINK	:1;		//  ஥ ஫ PHY-஢  稨 祭  
	volatile unsigned	PHY_INT_POL		:1;		//  ஥ ஫ PHY-஢  ᬥ ୮ ᨣ   
	volatile unsigned	PHY_INT_JAB		:1;		//  ஥ ஫ PHY-஢  ॢ襭 ६ । ᨬ쭮 ࠧ襭
	volatile unsigned	PHY_INT_JAM		:1;		//  ஥ ஫ PHY-஢  । JAM ᫥⥫쭮  砥  
	volatile unsigned	reserved1		:2;		// (१ࢨ஢)
#else	//__BIT_ORDER_REVERSE__
	volatile unsigned	reserved1		:2;		// (१ࢨ஢)
	volatile unsigned	PHY_INT_JAM		:1;		//  ஥ ஫ PHY-஢  । JAM ᫥⥫쭮  砥  
	volatile unsigned	PHY_INT_JAB		:1;		//  ஥ ஫ PHY-஢  ॢ襭 ६ । ᨬ쭮 ࠧ襭
	volatile unsigned	PHY_INT_POL		:1;		//  ஥ ஫ PHY-஢  ᬥ ୮ ᨣ   
	volatile unsigned	PHY_INT_LINK	:1;		//  ஥ ஫ PHY-஢  稨 祭  
	volatile unsigned	PHY_INT_COL		:1;		//  ஥ ஫ PHY-஢  稨   
	volatile unsigned	PHY_INT_CRS		:1;		//  ஥ ஫ PHY-஢  稨 饩  
	volatile unsigned	reserved2		:2;		// (१ࢨ஢)
	volatile unsigned	PHY_EXT_LINK	:1;		//   譥 ஫ PHY-஢  稨 祭  
	volatile unsigned	reserved3		:3;		// (१ࢨ஢)
	volatile unsigned	PHY_EXT_COL		:1;		//   譥 ஫ PHY-஢  稨   
	volatile unsigned	PHY_EXT_CRS		:1;		//   譥 ஫ PHY-஢  稨 饩  
#endif	//__BIT_ORDER_REVERSE__
} t_bits_PHY_STAT;

typedef	union	MAC_CTRL
{
			unsigned int		all;
			t_bits_MAC_CTRL		bit;
} t_MAC_CTRL;

typedef	union	MAC_COLLCONF
{
			unsigned int		all;
			t_bits_MAC_COLLCONF	field;
} t_MAC_COLLCONF;


typedef	union	INT_SOURCE
{
	volatile unsigned int		all;
			t_bits_MAC_INT		bit;
} t_INT_SOURCE;

typedef	union	INT_MASK
{
			unsigned int		all;
			t_bits_MAC_INT		bit;
} t_INT_MASK;

typedef union	GCTRL
{
			unsigned int 		all;
			t_bits_GCTRL		bit;
} t_GCTRL;

typedef union	PHY_CTRL
{
			unsigned int 		all;
			t_bits_PHY_CTRL		bit;
} t_PHY_CTRL;

typedef union	PHY_STAT
{
	volatile unsigned int 		all;
			t_bits_PHY_STAT		bit;
} t_PHY_STAT;



typedef	struct MAC	
{
			t_MAC_CTRL			MAC_CTRL;			//  ࠢ MAC-஢ ஫
			t_MAC_PACKETLEN		PACKETLEN;			//  ࠢ ࠭栬 ⨬  ⮢(MinFrame  MaxFrame)
			t_MAC_COLLCONF		COLLCONF;			//  ࠢ ࠡ⪨ 
			unsigned int		IPGT;				//   ⭮ ࢠ
			unsigned int		MAC_ADDR[3];		//   MAC- ஫
			unsigned int		HASH[4];			//   HASH-⠡  ७ 䨫樨 MAC-ᮢ
			t_INT_MASK			INT_MASK;			//  ᪨஢ 뢠
			t_INT_SOURCE		INT_SOURCE;			//  䫠 뢠
			t_PHY_CTRL			PHY_CTRL;			//  ࠢ PHY-஢ ஫
			t_PHY_STAT			PHY_STAT;			//  ﭨ PHY-஢ ஫

			 unsigned int 		RXBF_HEAD;			//  ""  
	volatile unsigned int 		RXBF_TAIL;			//  "墮"  
			 unsigned int 		TXBF_HEAD;			//  ""   (१ࢨ஢)
	volatile unsigned int 		TXBF_TAIL;			//  ""   (१ࢨ஢)

	volatile unsigned int 		STAT_RX_ALL;		// 稪 - 室 ⮢ 襤  -஢
	volatile unsigned int 		STAT_RX_OK;			// 稪 - ᯥ譮 ਭ 室 ⮢ (!!!  ⠢  ERROR_FRAME_EN - ⠥  )
	volatile unsigned int 		STAT_RX_OVF;		// 稪 - 室 ⮢, 맢 ९  
	volatile unsigned int 		STAT_RX_LOST;		// 稪 - 室 ⮢,  - ⮢ -஢  ਬ (⮢ ਯ)
	volatile unsigned int 		STAT_TX_ALL;		// 稪 - 室 ⮢
	volatile unsigned int 		STAT_TX_OK;			// 稪 - ᯥ譮 ᫠ 室 ⮢
	
			 unsigned int 		base_MAC_RxBF;		// ⥫ 砫    ᭮ ࠭⢥ ஫ (default = 0x0000)
			 unsigned int 		base_MAC_TxBF;		// ⥫ 砫    ᭮ ࠭⢥ ஫ (default = 0x1000)
			 unsigned int 		base_MAC_RxBD;		// ⥫ 砫 ⠡ ஢   ᭮ ࠭⢥ ஫ (default = 0x0800)
			 unsigned int 		base_MAC_TxBD;		// ⥫ 砫 ⠡ ஢   ᭮ ࠭⢥ ஫ (default = 0x1800)
			 unsigned int 		base_MAC_RG;		// ⥫ ᯮ  ॣ஢ ࠢ ஫ (default = 0x1FC0)
	t_GCTRL						GCTRL;				//  ࠢ 譨 䥩ᠬ ஫
} t_MAC;


#endif	// __MAC_TYPES__

