/*
 * FLASH_test.c
 *
 *  Created on: 3.12.2012
 *      Author: sidorov.a
 */

/* Includes ------------------------------------------------------------------*/
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include "stdint.h"
#include "std_def.h"
#include <MDR32F9Qx_port.h>
//  
#include "FLASH_test.h"
#include "MDR32F9Qx_ssp.h"
#include "MDR32Fx.h"
#include "MDR32F9Qx_ebc.h"
#include "std_def.h"
#include "types.h"
#include "MDR32F9Qx_timer.h"



#define SERIAL_MODE


static PORT_InitTypeDef My_PortInitStructure;
static SSP_InitTypeDef  My_SSP_InitStruct;


//       
uint16_t MSBtoLSB(uint16_t data, uint32_t size)
{
	uint16_t tmp = 0;
	uint32_t i = 0;

	for(i = 0; i < size; i++){
		tmp	= tmp | (((data&(1<<i))>>i)<<(size-i-1));
	}
	return tmp;
}

//       
uint16_t LSBtoMSB(uint16_t data, uint32_t size)
{
	uint16_t tmp = 0;
	uint32_t i = 0;

	for(i = 0; i < size; i++){
		tmp |= ((((data & (1<<(size - 1 - i)) )) >> (size - 1 - i)))<<(i);
	}
	return tmp;
}


#ifdef SERIAL_MODE
//   FLASH    
void vTest_Ext_FLASH( void )
{


	//       80  !!!
		
	//    SPI
    My_PortInitStructure.PORT_Pin = (PORT_Pin_12 | PORT_Pin_13 | PORT_Pin_14 | PORT_Pin_15);
    My_PortInitStructure.PORT_OE = PORT_OE_OUT;
    My_PortInitStructure.PORT_FUNC = PORT_FUNC_ALTER;
    My_PortInitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
    My_PortInitStructure.PORT_MODE = PORT_MODE_DIGITAL;	
	PORT_Init(MDR_PORTB, &My_PortInitStructure);

	//  SPI
	SSP_DeInit(MDR_SSP1);
	SSP_BRGInit(MDR_SSP1, SSP_HCLKdiv2);	//   
	SSP_StructInit(&My_SSP_InitStruct);
	// Initialize the SSP_WordLength member
	My_SSP_InitStruct.SSP_WordLength = SSP_WordLength16b;
	My_SSP_InitStruct.SSP_FRF = SSP_FRF_SPI_Motorola;
	My_SSP_InitStruct.SSP_SPO = SSP_SPO_High;
	My_SSP_InitStruct.SSP_SPH = SSP_SPH_2Edge;
	My_SSP_InitStruct.SSP_CPSDVSR = 8;
	My_SSP_InitStruct.SSP_SCR = 0;
	//  F_SSPCLK / ( CPSDVR * (1 + SCR) ) = 40 / (8 * (1 + 0)) = 5     */
	//  F_SSPCLK / ( CPSDVR * (1 + SCR) ) = 40 / (2 * (1 + 9)) = 2      */
	SSP_Init(MDR_SSP1, &My_SSP_InitStruct);
	SSP_Cmd(MDR_SSP1, ENABLE);

	//  FSS   
    My_PortInitStructure.PORT_Pin = PORT_Pin_12 | PORT_Pin_13;
    My_PortInitStructure.PORT_OE = PORT_OE_OUT;
    My_PortInitStructure.PORT_FUNC = PORT_FUNC_PORT;
    My_PortInitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
    My_PortInitStructure.PORT_MODE = PORT_MODE_DIGITAL;
    My_PortInitStructure.PORT_PULL_DOWN = PORT_PULL_DOWN_ON;
	PORT_Init(MDR_PORTB, &My_PortInitStructure);

	//  PB14 - SPI_Rx     
    My_PortInitStructure.PORT_Pin = PORT_Pin_14;
    My_PortInitStructure.PORT_OE = PORT_OE_IN;
    My_PortInitStructure.PORT_FUNC = PORT_FUNC_PORT;
    My_PortInitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
    My_PortInitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_Init(MDR_PORTB, &My_PortInitStructure);

	// CS2  FLAH 
	My_PortInitStructure.PORT_Pin = PORT_Pin_14;
	My_PortInitStructure.PORT_OE = PORT_OE_OUT;
	My_PortInitStructure.PORT_FUNC = PORT_FUNC_PORT;
	My_PortInitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
	My_PortInitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_Init(MDR_PORTE, &My_PortInitStructure);

	// OE  WE  FLASH 
	My_PortInitStructure.PORT_Pin = PORT_Pin_1 | PORT_Pin_2;
	My_PortInitStructure.PORT_OE = PORT_OE_OUT;
	My_PortInitStructure.PORT_FUNC = PORT_FUNC_PORT;
	My_PortInitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
	My_PortInitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_Init(MDR_PORTC, &My_PortInitStructure);



	uint16_t addr = 0;
	uint16_t data = 0x1234;


	uint32_t wait = 0;
	volatile uint32_t i = 32;


		uint32_t num_test = 0;
		uint16_t pattern = 0;
		for(num_test = 0; num_test < 16; num_test++){

			pattern = (1<<num_test);

			//  
			volatile uint32_t error = 0;
			//FLASH_SECTOR_1
			//FLASH_SECTOR_2
			//FLASH_SECTOR_3
			//FLASH_SECTOR_4
			error = Erase_Sector_Flash(FLASH_SECTOR_2);

			//    SPI
			//  SSP1
			SSP_Cmd(MDR_SSP1, DISABLE);
			//   SPI1
			My_SSP_InitStruct.SSP_CPSDVSR = 8; //  F_SSPCLK / ( CPSDVR * (1 + SCR) ) = 40 / (8 * (1 + 0)) = 5     */
			My_SSP_InitStruct.SSP_SCR = 0;
			SSP_Init(MDR_SSP1, &My_SSP_InitStruct);
			//  SPI1
			SSP_Cmd(MDR_SSP1, ENABLE);

			//    16361 4 (512  8)
			//     512 / 4 = 128
			//  16-        0x0000 - 0xFFFF,
			int i = 0;
			//  32 16-  
			for (i = 0; i < 65536; i++){
				if((i&1) == 0)
					error = Write_Halfword_To_Flash( (uint16_t)i, (uint16_t)pattern, FLASH_SECTOR_2);
				else
					error = Write_Halfword_To_Flash( (uint16_t)i, (uint16_t)(~pattern), FLASH_SECTOR_2);
			}

			uint16_t tmp = 0;
			uint16_t Receive_Data = 0;
			//  32 16-  
			uint32_t Num_errors = 0;
			for (i = 0; i < 65536; i++){
				Receive_Data = Read_Halfword_From_Flash( (uint16_t)i, FLASH_SECTOR_2);
				if((i&1) == 0)
					tmp = pattern;
				else
					tmp = (~pattern);
				if(Receive_Data != tmp){
					Num_errors++;
				}
			}
		}
}
#endif // #ifdef SERIAL_MODE



#ifdef SERIAL_MODE
//     FLASH
uint32_t Erase_Sector_Flash(uint32_t Num_Sector)
{

    My_PortInitStructure.PORT_Pin = (PORT_Pin_13 | PORT_Pin_14 | PORT_Pin_15);
    My_PortInitStructure.PORT_OE = PORT_OE_OUT;
    My_PortInitStructure.PORT_FUNC = PORT_FUNC_ALTER;
    My_PortInitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
    My_PortInitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_Init(MDR_PORTB, &My_PortInitStructure);

	//    -  
	//    2    
	SSP_Cmd(MDR_SSP1, DISABLE);

	//  F_SSPCLK / ( CPSDVR * (1 + SCR) ) = 40 / (2 * (1 + 9)) = 2     
	My_SSP_InitStruct.SSP_CPSDVSR = 2;
	My_SSP_InitStruct.SSP_SCR = 9;

	SSP_Init(MDR_SSP1, &My_SSP_InitStruct);
	SSP_Cmd(MDR_SSP1, ENABLE);

	static uint16_t CMD = 0;
	static uint16_t cmd_lsb_full_cycle = 0;
	//  
	CMD                = MSBtoLSB( ((( CEB4 | NVRB4 | CEB3 | NVRB3 | CEB2 | NVRB2 | CEB1 |NVRB1 |  TMEN | BYTEB_16 | VREAD | OEB)&(~Num_Sector))<<2) | (1<<1), 15);
	cmd_lsb_full_cycle = MSBtoLSB( ((( CEB4 | NVRB4 | CEB3 | NVRB3 | CEB2 | NVRB2 | CEB1 |NVRB1 |  TMEN | BYTEB_16 | VREAD | OEB)&(~Num_Sector))<<2), 15);


	//      
	//  
	//     SPI
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	//  PB13    
	MDR_PORTB->FUNC = MDR_PORTB->FUNC&(~3<<26);

	//  
	MDR_PORTB->RXTX &= ~PORT_Pin_13;
	MDR_PORTB->RXTX |=  PORT_Pin_13;		//PORT_SetBits(MDR_PORTB, PORT_Pin_12);

	//   15 
		MDR_PORTB->RXTX &= ~PORT_Pin_13;
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->RXTX |= PORT_Pin_12;
		MDR_PORTB->RXTX |=  PORT_Pin_13;		//PORT_SetBits(MDR_PORTB, PORT_Pin_12);
		//MDR_PORTB->RXTX &= ~PORT_Pin_13;
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->FUNC = ((MDR_PORTB->FUNC&(~3<<26)) | (PORT_FUNC_ALTER<<26));

	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength15b;
	SSP_SendData(MDR_SSP1, CMD);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength12b;
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_TNF) == RESET);
	SSP_SendData(MDR_SSP1, ADDR_555);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength8b;
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_TNF) == RESET);
	SSP_SendData(MDR_SSP1, DATA_AA);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	//    CLK
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength4b;
	SSP_SendData(MDR_SSP1, 0x00);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);


	//   
	//  PB13    
	MDR_PORTB->FUNC = MDR_PORTB->FUNC&(~3<<26);
	//   15 
		MDR_PORTB->RXTX &= ~PORT_Pin_13;
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->RXTX |= PORT_Pin_12;
		MDR_PORTB->RXTX |=  PORT_Pin_13;		//PORT_SetBits(MDR_PORTB, PORT_Pin_12);
		//MDR_PORTB->RXTX &= ~PORT_Pin_13;
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->FUNC = ((MDR_PORTB->FUNC&(~3<<26)) | (PORT_FUNC_ALTER<<26));


	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength15b;
	SSP_SendData(MDR_SSP1, CMD);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength12b;
	SSP_SendData(MDR_SSP1, ADDR_AAA);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength8b;
	SSP_SendData(MDR_SSP1, DATA_55);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	//    CLK
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength4b;
	SSP_SendData(MDR_SSP1, 0x00);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);


	//   
	//  PB13    
	MDR_PORTB->FUNC = MDR_PORTB->FUNC&(~3<<26);
	//   15 
		MDR_PORTB->RXTX &= ~PORT_Pin_13;
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->RXTX |= PORT_Pin_12;
		MDR_PORTB->RXTX |=  PORT_Pin_13;		//PORT_SetBits(MDR_PORTB, PORT_Pin_12);
		//MDR_PORTB->RXTX &= ~PORT_Pin_13;
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->FUNC = ((MDR_PORTB->FUNC&(~3<<26)) | (PORT_FUNC_ALTER<<26));

	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength15b;
	SSP_SendData(MDR_SSP1, CMD);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength12b;
	SSP_SendData(MDR_SSP1, ADDR_555);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength8b;
	SSP_SendData(MDR_SSP1, DATA_80);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	//    CLK
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength4b;
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_TNF) == RESET);
	SSP_SendData(MDR_SSP1, 0x00);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	//   
	//  PB13    
	MDR_PORTB->FUNC = MDR_PORTB->FUNC&(~3<<26);

	//   15 
		MDR_PORTB->RXTX &= ~PORT_Pin_13;
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->RXTX |= PORT_Pin_12;
		MDR_PORTB->RXTX |=  PORT_Pin_13;		//PORT_SetBits(MDR_PORTB, PORT_Pin_12);
		//MDR_PORTB->RXTX &= ~PORT_Pin_13;
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->FUNC = ((MDR_PORTB->FUNC&(~3<<26)) | (PORT_FUNC_ALTER<<26));

	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength15b;
	SSP_SendData(MDR_SSP1, CMD);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength12b;
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_TNF) == RESET);
	SSP_SendData(MDR_SSP1, ADDR_555);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength8b;
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_TNF) == RESET);
	SSP_SendData(MDR_SSP1, DATA_AA);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	//    CLK
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength4b;
	SSP_SendData(MDR_SSP1, 0x00);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);


	//   
	//  PB13    
	MDR_PORTB->FUNC = MDR_PORTB->FUNC&(~3<<26);
	//   15 
		MDR_PORTB->RXTX &= ~PORT_Pin_13;
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->RXTX |= PORT_Pin_12;
		MDR_PORTB->RXTX |=  PORT_Pin_13;		//PORT_SetBits(MDR_PORTB, PORT_Pin_12);
		//MDR_PORTB->RXTX &= ~PORT_Pin_13;
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->FUNC = ((MDR_PORTB->FUNC&(~3<<26)) | (PORT_FUNC_ALTER<<26));

	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength15b;
	SSP_SendData(MDR_SSP1, CMD);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength12b;
	SSP_SendData(MDR_SSP1, ADDR_AAA);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength8b;
	SSP_SendData(MDR_SSP1, DATA_55);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	//    CLK
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength4b;
	SSP_SendData(MDR_SSP1, 0x00);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);


	//   
	//   
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
	//  PB13    
	MDR_PORTB->FUNC = MDR_PORTB->FUNC&(~3<<26);
	//   15 
		MDR_PORTB->RXTX &= ~PORT_Pin_13;
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->RXTX |= PORT_Pin_12;
		MDR_PORTB->RXTX |=  PORT_Pin_13;		//PORT_SetBits(MDR_PORTB, PORT_Pin_12);
		//MDR_PORTB->RXTX &= ~PORT_Pin_13;
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->FUNC = ((MDR_PORTB->FUNC&(~3<<26)) | (PORT_FUNC_ALTER<<26));

	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength15b;
	SSP_SendData(MDR_SSP1, cmd_lsb_full_cycle);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength16b;
	SSP_SendData(MDR_SSP1, ADDR_555_16);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
	//  
	//MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength12b;
	SSP_SendData(MDR_SSP1, DATA_10);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	//       2 
	//       0,5 
	//       FLASH  27500 SPI 
	//    28000

	//  PB15    
	/*MDR_PORTB->OE  &= ~PORT_Pin_15;
	MDR_PORTB->FUNC = MDR_PORTB->FUNC&(~(3<<30));

	uint32_t i = 28000;
	while(i > 0){
		while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_TNF) == RESET);
		SSP_SendData(MDR_SSP1, 0x00);
		i--;
	}
	//      FIFO
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
	PORT_ResetBits(MDR_PORTB, PORT_Pin_12);*/

	//  PB15    
	//MDR_PORTB->OE  &= ~PORT_Pin_15;
	//MDR_PORTB->FUNC = MDR_PORTB->FUNC&(~(3<<30));
    My_PortInitStructure.PORT_Pin = (PORT_Pin_14 | PORT_Pin_15);
    My_PortInitStructure.PORT_OE = PORT_OE_IN;
    My_PortInitStructure.PORT_FUNC = PORT_FUNC_PORT;
    My_PortInitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
    My_PortInitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_Init(MDR_PORTB, &My_PortInitStructure);

	uint32_t i = 28000;
	uint32_t busy = 0;
	uint32_t busy_up = 0;
	uint32_t busy_down = 0;
	uint32_t busy_up_again = 0;

	while(i > 0){
		while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_TNF) == RESET);
		SSP_SendData(MDR_SSP1, 0x00);
		busy = PORT_ReadInputDataBit(MDR_PORTB, PORT_Pin_14);
		if((busy == 1) && (busy_up == 0)){ // busy 
			busy_up = 1;
		}
		else{
			if((busy == 0) && (busy_up == 1)) { //  busy 
				busy_down = 1;
			}
			else{
				if((busy == 1) && (busy_up == 1) && (busy_down == 1)){
					busy_up_again = 1;
					break;
				}
			}
		}
		i--;
	}
	//      FIFO
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	if(busy_up_again == 1){
		return ERR_OK;
	}
	else{
		return ERR_SECTOR_NOT_ERRASE;
	}

} // void Erase_Sector_Flash(uint32_t Num_Sector)
#endif // #ifdef SERIAL_MODE



#ifdef SERIAL_MODE
//      FLASH    
uint32_t Write_Halfword_To_Flash(uint16_t addr, uint16_t data, uint32_t Num_block)
{
	uint16_t CMD = 0;
	uint16_t cmd_lsb_full_cycle = 0;

    My_PortInitStructure.PORT_Pin = (PORT_Pin_13 | PORT_Pin_14 | PORT_Pin_15);
    My_PortInitStructure.PORT_OE = PORT_OE_OUT;
    My_PortInitStructure.PORT_FUNC = PORT_FUNC_ALTER;
    My_PortInitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
    My_PortInitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_Init(MDR_PORTB, &My_PortInitStructure);


	//          
	CMD                = ((( CEB4 | NVRB4 | CEB3 | NVRB3 | CEB2 | NVRB2 | CEB1 | NVRB1 | TMEN | BYTEB_16 | VREAD | OEB)&(~Num_block))<<2) | (1<<1);
	//          
	cmd_lsb_full_cycle =  (( CEB4 | NVRB4 | CEB3 | NVRB3 | CEB2 | NVRB2 | CEB1 | NVRB1 | TMEN | BYTEB_16 | VREAD | OEB)&(~Num_block))<<2;

	//  
	CMD                = MSBtoLSB(CMD               , 15)&0x7FFF;
	cmd_lsb_full_cycle = MSBtoLSB(cmd_lsb_full_cycle, 15)&0x7FFF;

	//  
	PORT_SetBits(MDR_PORTE, PORT_Pin_14);
	PORT_SetBits(MDR_PORTC, PORT_Pin_1 | PORT_Pin_2);

 	//     - 
	//  PB13    
	MDR_PORTB->FUNC = MDR_PORTB->FUNC&(~3<<26);

	//  
	MDR_PORTB->RXTX &= ~PORT_Pin_13;
	MDR_PORTB->RXTX |=  PORT_Pin_13;		//PORT_SetBits(MDR_PORTB, PORT_Pin_12);

	//  
	//     SPI
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	//   15 
		MDR_PORTB->RXTX &= ~PORT_Pin_13;
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->RXTX |= PORT_Pin_12;
		MDR_PORTB->RXTX |=  PORT_Pin_13;		//PORT_SetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->FUNC = ((MDR_PORTB->FUNC&(~3<<26)) | (PORT_FUNC_ALTER<<26));

	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength15b;
	SSP_SendData(MDR_SSP1, CMD);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength12b;
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_TNF) == RESET);
	SSP_SendData(MDR_SSP1, ADDR_555);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength8b;
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_TNF) == RESET);
	SSP_SendData(MDR_SSP1, DATA_AA);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	//    CLK
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength4b;
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_TNF) == RESET);
	SSP_SendData(MDR_SSP1, 0x00);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);


	//   
	//  PB13    
	MDR_PORTB->FUNC = MDR_PORTB->FUNC&(~3<<26);
	//   15 
		MDR_PORTB->RXTX &= ~PORT_Pin_13;
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->RXTX |= PORT_Pin_12;
		MDR_PORTB->RXTX |=  PORT_Pin_13;		//PORT_SetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->FUNC = ((MDR_PORTB->FUNC&(~3<<26)) | (PORT_FUNC_ALTER<<26));

	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength15b;
	SSP_SendData(MDR_SSP1, CMD);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength12b;
	SSP_SendData(MDR_SSP1, ADDR_AAA);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength8b;
	SSP_SendData(MDR_SSP1, DATA_55);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	//    CLK
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength4b;
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_TNF) == RESET);
	SSP_SendData(MDR_SSP1, 0x00);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);


	//   
	//  PB13    
	MDR_PORTB->FUNC = MDR_PORTB->FUNC&(~3<<26);
	//   15 
		MDR_PORTB->RXTX &= ~PORT_Pin_13;
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->RXTX |= PORT_Pin_12;
		MDR_PORTB->RXTX |=  PORT_Pin_13;		//PORT_SetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->FUNC = ((MDR_PORTB->FUNC&(~3<<26)) | (PORT_FUNC_ALTER<<26));

	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength15b;
	SSP_SendData(MDR_SSP1, CMD);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength12b;
	SSP_SendData(MDR_SSP1, ADDR_555);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength8b;
	SSP_SendData(MDR_SSP1, DATA_A0);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	//    CLK
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength4b;
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_TNF) == RESET);
	SSP_SendData(MDR_SSP1, 0x00);

	//   -  
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
	//  PB13    
	MDR_PORTB->FUNC = MDR_PORTB->FUNC&(~3<<26);
	//   15 
		MDR_PORTB->RXTX &= ~PORT_Pin_13;
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->RXTX |= PORT_Pin_12;
		MDR_PORTB->RXTX |=  PORT_Pin_13;		//PORT_SetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->FUNC = ((MDR_PORTB->FUNC&(~3<<26)) | (PORT_FUNC_ALTER<<26));

	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength15b;
	SSP_SendData(MDR_SSP1, cmd_lsb_full_cycle);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength16b;
	SSP_SendData(MDR_SSP1, MSBtoLSB(addr,16));
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
	//  
	SSP_SendData(MDR_SSP1, MSBtoLSB(data,16));
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	//        = 200 
	//   SPI =  5 ,      0,2 ,
	//         FLASH 
	//  200/(16*0,2) = 125 ,    164 .

	//  PB15    
	//MDR_PORTB->OE  &= ~PORT_Pin_15;
	//MDR_PORTB->FUNC = MDR_PORTB->FUNC&(~(3<<30));
    My_PortInitStructure.PORT_Pin = (PORT_Pin_14 | PORT_Pin_15);
    My_PortInitStructure.PORT_OE = PORT_OE_IN;
    My_PortInitStructure.PORT_FUNC = PORT_FUNC_PORT;
    My_PortInitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
    My_PortInitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_Init(MDR_PORTB, &My_PortInitStructure);

	uint32_t i = 64;
	uint32_t busy = 0;
	uint32_t busy_up = 0;
	uint32_t busy_down = 0;
	uint32_t busy_up_again = 0;

	while(i > 0){
		while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_TNF) == RESET);
		SSP_SendData(MDR_SSP1, 0x00);
		busy = PORT_ReadInputDataBit(MDR_PORTB, PORT_Pin_14);
		if((busy == 1) && (busy_up == 0)){ // busy 
			busy_up = 1;
		}
		else{
			if((busy == 0) && (busy_up == 1)) { //  busy 
				busy_down = 1;
			}
			else{
				if((busy == 1) && (busy_up == 1) && (busy_down == 1)){
					busy_up_again = 1;
					break;
				}
			}
		}
		i--;
	}
	//      FIFO
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	if(busy_up_again == 1){
		return ERR_OK;
	}
	else{
		return ERR_DATA_NOT_WRITTEN;
	}

} // void Write_Halfword_To_Flash(uint16_t addr, uint16_t data, uint16_t Num_block)
#endif // #ifdef SERIAL_MODE



#ifdef SERIAL_MODE
//     FLASH 
uint16_t Read_Halfword_From_Flash(uint16_t addr, uint32_t Num_block)
{

	//    FLASH
	uint16_t Received_Data = 0;
	//         BUSY
	uint16_t Remaining_Bits = 0;

    My_PortInitStructure.PORT_Pin = (PORT_Pin_13 | PORT_Pin_14 | PORT_Pin_15);
    My_PortInitStructure.PORT_OE = PORT_OE_OUT;
    My_PortInitStructure.PORT_FUNC = PORT_FUNC_ALTER;
    My_PortInitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
    My_PortInitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_Init(MDR_PORTB, &My_PortInitStructure);


	//     
	uint16_t CMD_read = 0;
	CMD_read = MSBtoLSB( ( ( ( ( CEB4 | NVRB4 | CEB3 | NVRB3 | CEB2 | NVRB2 | CEB1 | NVRB1 | TMEN | BYTEB_16 | VREAD | WEB) & ( ~Num_block ) )<<2 ) | (1<<0) ), 15);

	//       
	//  
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
	//  PB13   /
	MDR_PORTB->FUNC = MDR_PORTB->FUNC&(~3<<26);
	//  
	MDR_PORTB->RXTX &= ~PORT_Pin_13;
	MDR_PORTB->RXTX |=  PORT_Pin_13;			//PORT_SetBits(MDR_PORTB, PORT_Pin_12);

	//   15 
		MDR_PORTB->RXTX &= ~PORT_Pin_13;
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->RXTX |= PORT_Pin_12;
		MDR_PORTB->RXTX |=  PORT_Pin_13;		//PORT_SetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->RXTX &= ~PORT_Pin_12;			//PORT_ResetBits(MDR_PORTB, PORT_Pin_12);
	MDR_PORTB->FUNC = ((MDR_PORTB->FUNC&(~3<<26)) | (PORT_FUNC_ALTER<<26));

	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength15b;
	SSP_SendData(MDR_SSP1, CMD_read);
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
	//  
	MDR_SSP1->CR0 = (MDR_SSP1->CR0&0xFFF0)|SSP_WordLength16b;
	SSP_SendData(MDR_SSP1, MSBtoLSB(addr,16));
	while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);

	//   
	// PB14 - SPI_Rx
	My_PortInitStructure.PORT_Pin = PORT_Pin_14;
	My_PortInitStructure.PORT_OE = PORT_OE_IN;
	My_PortInitStructure.PORT_FUNC = PORT_FUNC_ALTER;
	My_PortInitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
	My_PortInitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_Init(MDR_PORTB, &My_PortInitStructure);

	//  PB15    
	MDR_PORTB->OE  &= ~PORT_Pin_15;
	MDR_PORTB->FUNC = MDR_PORTB->FUNC&(~(3<<30));
	uint16_t tmp = 0;
	uint32_t end_receive_data = 0;
	//  FIFO 
	while(SSP_GetFlagStatus(MDR_SSP1,SSP_FLAG_RNE) != 0)
		SSP_ReceiveData(MDR_SSP1);


	int i = 0;
	while(1){
		//      
		SSP_SendData(MDR_SSP1, 0x00);
		while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
		//     SPI
		tmp = SSP_ReceiveData(MDR_SSP1);
		//     
		while(SSP_GetFlagStatus(MDR_SSP1, SSP_FLAG_BSY) == SET);
		if(end_receive_data){
			Received_Data |= tmp>>(16 - Remaining_Bits);
			Received_Data = LSBtoMSB(Received_Data, 16);
			break;
		}
		//    "1"  
		for(i = 0; i < 16; i++){
			if(tmp&(1<<(15 - i))){
				Remaining_Bits = i + 1;
				Received_Data = tmp<<Remaining_Bits;
				end_receive_data = 1;
				break;
			}
		}
	} // while(1){

	PORT_ResetBits(MDR_PORTB, PORT_Pin_12);

	return Received_Data;

} // uint16_t Read_Halfword_From_Flash(uint16_t addr, uint16_t Num_block)
#endif // #ifdef SERIAL_MODE
